# -*- coding: utf-8 -*-
from ..libhooke import WX_GOOD, ClickedPoint

import wxversion
wxversion.select(WX_GOOD)
from wx import PostEvent
import numpy as np
import scipy as sp
import copy
import os.path
import time


class curvetoolsCommands:

      def fit_interval_nm(self,start_index,plot,nm,backwards):
	  '''
	  Calculates the number of points to fit, given a fit interval in nm
	  start_index: index of point
	  plot: plot to use
	  backwards: if true, finds a point backwards.
	  '''
	  whatset=1 #FIXME: should be decidable
	  x_vect=plot.vectors[1][0]
	  
	  c=0
	  i=start_index
	  start=x_vect[start_index]
	  maxlen=len(x_vect)
	  while abs(x_vect[i]-x_vect[start_index])*(10**9) < nm:
	      if i==0 or i==maxlen-1: #we reached boundaries of vector!
		  return c
	      
	      if backwards:
		  i-=1
	      else:
		  i+=1
	      c+=1
	  return c



      def find_current_peaks(self,noflatten, a=True, maxpeak=True):
	    #Find peaks.
	    if a==True:
		  a=self.convfilt_config['mindeviation']
	    try:
		  abs_devs=float(a)
	    except:
		  print "Bad input, using default."
		  abs_devs=self.convfilt_config['mindeviation']

	    defplot=self.current.curve.default_plots()[0]
	    if not noflatten:
		flatten=self._find_plotmanip('flatten') #Extract flatten plotmanip
		defplot=flatten(defplot, self.current, customvalue=1) #Flatten curve before feeding it to has_peaks
	    pk_location,peak_size=self.has_peaks(defplot, abs_devs, maxpeak)
	    return pk_location, peak_size


      def pickup_contact_point(self,N=1,whatset=1):
	    '''macro to pick up the contact point by clicking'''
	    contact_point=self._measure_N_points(N=1, whatset=1)[0]
	    contact_point_index=contact_point.index
	    self.wlccontact_point=contact_point
	    self.wlccontact_index=contact_point.index
	    self.wlccurrent=self.current.path
	    return contact_point, contact_point_index



      def baseline_points(self,peak_location, displayed_plot):
            clicks=self.config['baseline_clicks']
            if clicks==0:
                self.basepoints=[]
                base_index_0=peak_location[-1]+self.fit_interval_nm(peak_location[-1], displayed_plot, self.config['auto_right_baseline'],False)
                self.basepoints.append(self._clickize(displayed_plot.vectors[1][0],displayed_plot.vectors[1][1],base_index_0))
                base_index_1=self.basepoints[0].index+self.fit_interval_nm(self.basepoints[0].index, displayed_plot, self.config['auto_left_baseline'],False)
                self.basepoints.append(self._clickize(displayed_plot.vectors[1][0],displayed_plot.vectors[1][1],base_index_1))
            elif clicks>0:
                print 'Select baseline'
                if clicks==1:
                    self.basepoints=self._measure_N_points(N=1, whatset=1)
                    base_index_1=self.basepoints[0].index+self.fit_interval_nm(self.basepoints[0].index, displayed_plot, self.config['auto_left_baseline'], False)
                    self.basepoints.append(self._clickize(displayed_plot.vectors[1][0],displayed_plot.vectors[1][1],base_index_1))
                else:
                    self.basepoints=self._measure_N_points(N=2, whatset=1)
            
            self.basecurrent=self.current.path
            return self.basepoints



class InfoCommand (Command):
    """Execute a system command and report the output.
    """
    def __init__(self):
        super(SystemCommand, self).__init__(
            name='system',
            arguments=[
                Argument(
    name='command', type='string', optional=False, count=-1,
    help="""
Command line to execute.
""".strip())
],
            help=self.__doc__)

    def _run(self, hooke, inqueue, outqueue, params):
        os.system(params['command'])

    def do_info(self,args):
        '''
        INFO
        ----
        Returns informations about the current curve.
        '''
        print 'Path: ',self.current.path
        print 'Experiment: ',self.current.curve.experiment
        print 'Filetype: ',self.current.curve.filetype
        for plot in self.current.curve.default_plots():
            for set in plot.vectors:
                lengths=[len(item) for item in set]
                print 'Data set size: ',lengths


    def help_current(self):
        print '''
CURRENT
Prints the current curve path.
------
Syntax: current
        '''
    def do_current(self,args):
        print self.current.path


    def help_txt(self):
        print '''
TXT
Saves the current curve as a text file
Columns are, in order:
X1 , Y1 , X2 , Y2 , X3 , Y3 ...

-------------
Syntax: txt [filename] {plot to export}
        '''
    def do_txt(self,args):

        def transposed2(lists, defval=0):
            '''
            transposes a list of lists, i.e. from [[a,b,c],[x,y,z]] to [[a,x],[b,y],[c,z]] without losing
            elements
            (by Zoran Isailovski on the Python Cookbook online)
            '''
            if not lists: return []
            return map(lambda *row: [elem or defval for elem in row], *lists)

        whichplot=0
        args=args.split()
        if len(args)==0:
            filename=linp.safeinput('Filename?',[self.current.path+'.txt'])
        else:
            filename=linp.checkalphainput(args[0],self.current.path+'.txt',[])
            try:
                whichplot=int(args[1])
            except:
                pass

	try:
            outofplot=self.plots[whichplot].vectors
        except:
            print "Plot index out of range."
	    return 0

        columns=[]     
        for dataset in self.plots[whichplot].vectors:
            for i in range(0,len(dataset)):
                columns.append([])
                for value in dataset[i]:
                    columns[-1].append(str(value))

        rows=transposed2(columns, 'nan')
        rows=[' , '.join(item) for item in rows]
        text='\n'.join(rows)

        txtfile=open(filename,'w+')
        #Save units of measure in header
        txtfile.write('X:'+self.plots[whichplot].units[0]+'\n')
        txtfile.write('Y:'+self.plots[whichplot].units[1]+'\n')
        txtfile.write(text)
        txtfile.close()
